------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2011 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Abstract_Item_Models;
with Qt4.Mime_Datas;
with Qt4.Model_Index_Lists;
with Qt4.Model_Indices;
with Qt4.Sizes;
with Qt4.String_Lists;
with Qt4.Variants;
with Qt_Ada.Internals.Objects.Object_Proxies;

package Qt_Ada.Internals.Objects.Abstract_Item_Model_Proxies is

   pragma Elaborate_Body;

   type Q_Abstract_Item_Model_Proxy is
     new Qt_Ada.Internals.Objects.Object_Proxies.Q_Object_Proxy
       and Qt4.Abstract_Item_Models.Q_Abstract_Item_Model with null record;

   function Buddy
    (Self : not null access constant Q_Abstract_Item_Model_Proxy;
     Index : Qt4.Model_Indices.Q_Model_Index)
       return Qt4.Model_Indices.Q_Model_Index;

   function Can_Fetch_More
    (Self : not null access constant Q_Abstract_Item_Model_Proxy;
     Parent : Qt4.Model_Indices.Q_Model_Index)
       return Standard.Boolean;

   function Column_Count
    (Self : not null access constant Q_Abstract_Item_Model_Proxy;
     Parent : Qt4.Model_Indices.Q_Model_Index)
       return Qt4.Q_Integer;

   function Drop_Mime_Data
    (Self : not null access Q_Abstract_Item_Model_Proxy;
     Data : access Qt4.Mime_Datas.Q_Mime_Data'Class;
     Action : Qt4.Drop_Action;
     Row : Qt4.Q_Integer;
     Column : Qt4.Q_Integer;
     Parent : Qt4.Model_Indices.Q_Model_Index)
       return Standard.Boolean;

   procedure Fetch_More
    (Self : not null access Q_Abstract_Item_Model_Proxy;
     Parent : Qt4.Model_Indices.Q_Model_Index);

   function Has_Children
    (Self : not null access constant Q_Abstract_Item_Model_Proxy;
     Parent : Qt4.Model_Indices.Q_Model_Index)
       return Standard.Boolean;

   function Has_Index
    (Self : not null access constant Q_Abstract_Item_Model_Proxy;
     Row : Qt4.Q_Integer;
     Column : Qt4.Q_Integer;
     Parent : Qt4.Model_Indices.Q_Model_Index)
       return Standard.Boolean;

   function Index
    (Self : not null access constant Q_Abstract_Item_Model_Proxy;
     Row : Qt4.Q_Integer;
     Column : Qt4.Q_Integer;
     Parent : Qt4.Model_Indices.Q_Model_Index)
       return Qt4.Model_Indices.Q_Model_Index;

   function Insert_Columns
    (Self : not null access Q_Abstract_Item_Model_Proxy;
     Column : Qt4.Q_Integer;
     Count : Qt4.Q_Integer;
     Parent : Qt4.Model_Indices.Q_Model_Index)
       return Standard.Boolean;

   function Insert_Rows
    (Self : not null access Q_Abstract_Item_Model_Proxy;
     Row : Qt4.Q_Integer;
     Count : Qt4.Q_Integer;
     Parent : Qt4.Model_Indices.Q_Model_Index)
       return Standard.Boolean;

   function Mime_Data
    (Self : not null access constant Q_Abstract_Item_Model_Proxy;
     Indexes : Qt4.Model_Index_Lists.Q_Model_Index_List)
       return access Qt4.Mime_Datas.Q_Mime_Data'Class;

   function Mime_Types
    (Self : not null access constant Q_Abstract_Item_Model_Proxy)
       return Qt4.String_Lists.Q_String_List;

   function Parent
    (Self : not null access constant Q_Abstract_Item_Model_Proxy;
     Child : Qt4.Model_Indices.Q_Model_Index)
       return Qt4.Model_Indices.Q_Model_Index;

   function Remove_Columns
    (Self : not null access Q_Abstract_Item_Model_Proxy;
     Column : Qt4.Q_Integer;
     Count : Qt4.Q_Integer;
     Parent : Qt4.Model_Indices.Q_Model_Index)
       return Standard.Boolean;

   function Remove_Rows
    (Self : not null access Q_Abstract_Item_Model_Proxy;
     Row : Qt4.Q_Integer;
     Count : Qt4.Q_Integer;
     Parent : Qt4.Model_Indices.Q_Model_Index)
       return Standard.Boolean;

   function Row_Count
    (Self : not null access constant Q_Abstract_Item_Model_Proxy;
     Parent : Qt4.Model_Indices.Q_Model_Index)
       return Qt4.Q_Integer;

   function Span
    (Self : not null access constant Q_Abstract_Item_Model_Proxy;
     Index : Qt4.Model_Indices.Q_Model_Index)
       return Qt4.Sizes.Q_Size;

   procedure Revert
    (Self : not null access Q_Abstract_Item_Model_Proxy);

   function Submit
    (Self : not null access Q_Abstract_Item_Model_Proxy)
       return Standard.Boolean;

   overriding
   function Data
    (Self  : not null access Q_Abstract_Item_Model_Proxy;
     Index : Qt4.Model_Indices.Q_Model_Index;
     Role  : Qt4.Item_Data_Role := Qt4.Display_Role)
       return Qt4.Variants.Q_Variant;

   overriding
   function Flags
    (Self  : not null access constant Q_Abstract_Item_Model_Proxy;
     Index : Qt4.Model_Indices.Q_Model_Index)
       return Qt4.Item_Flags;

   overriding
   function Header_Data
    (Self        : not null access Q_Abstract_Item_Model_Proxy;
     Section     : Qt4.Q_Integer;
     Orientation : Qt4.Orientations;
     Role        : Qt4.Item_Data_Role := Qt4.Display_Role)
       return Qt4.Variants.Q_Variant;

   overriding
   function Set_Data
    (Self  : not null access Q_Abstract_Item_Model_Proxy;
     Index : Qt4.Model_Indices.Q_Model_Index;
     Value : Qt4.Variants.Q_Variant;
     Role  : Qt4.Item_Data_Role := Qt4.Edit_Role)
       return Boolean;

   overriding
   function Set_Header_Data
    (Self    : not null access Q_Abstract_Item_Model_Proxy;
     Section : Qt4.Q_Integer;
     Orient  : Qt4.Orientation;
     Value   : Qt4.Variants.Q_Variant;
     Role    : Qt4.Item_Data_Role := Qt4.Edit_Role)
       return Boolean;

end Qt_Ada.Internals.Objects.Abstract_Item_Model_Proxies;
